diff --git a/drivers/crypto/cnxk/cn10k_cryptodev_sec.h b/drivers/crypto/cnxk/cn10k_cryptodev_sec.h
index 878cf78..77faaa0 100644
--- a/drivers/crypto/cnxk/cn10k_cryptodev_sec.h
+++ b/drivers/crypto/cnxk/cn10k_cryptodev_sec.h
@@ -25,7 +25,7 @@ struct cn10k_tls_opt {
 	uint16_t mac_len : 7;
 };
 
-struct cn10k_sec_session {
+struct __rte_aligned(ROC_ALIGN) cn10k_sec_session {
 	uint8_t rte_sess[SEC_SESS_SIZE];
 
 	/** PMD private space */
@@ -57,7 +57,7 @@ struct cn10k_sec_session {
 		struct cn10k_ipsec_sa sa;
 		struct cn10k_tls_record tls_rec;
 	};
-} __rte_aligned(ROC_ALIGN);
+};
 
 static inline uint64_t
 cpt_inst_w7_get(struct roc_cpt *roc_cpt, void *cptr)
diff --git a/drivers/crypto/cnxk/cn10k_ipsec.h b/drivers/crypto/cnxk/cn10k_ipsec.h
index 0d1e14a..4e4e68f 100644
--- a/drivers/crypto/cnxk/cn10k_ipsec.h
+++ b/drivers/crypto/cnxk/cn10k_ipsec.h
@@ -18,14 +18,14 @@
 /* Forward declaration */
 struct cn10k_sec_session;
 
-struct cn10k_ipsec_sa {
+struct __rte_aligned(ROC_ALIGN) cn10k_ipsec_sa {
 	union {
 		/** Inbound SA */
 		struct roc_ot_ipsec_inb_sa in_sa;
 		/** Outbound SA */
 		struct roc_ot_ipsec_outb_sa out_sa;
 	};
-} __rte_aligned(ROC_ALIGN);
+};
 
 int cn10k_ipsec_session_create(struct cnxk_cpt_vf *vf, struct cnxk_cpt_qp *qp,
 			       struct rte_security_ipsec_xform *ipsec_xfrm,
diff --git a/drivers/crypto/cnxk/cn10k_tls.h b/drivers/crypto/cnxk/cn10k_tls.h
index 9635bdd..c6bd16d 100644
--- a/drivers/crypto/cnxk/cn10k_tls.h
+++ b/drivers/crypto/cnxk/cn10k_tls.h
@@ -16,14 +16,14 @@
 /* Forward declaration */
 struct cn10k_sec_session;
 
-struct cn10k_tls_record {
+struct __rte_aligned(ROC_ALIGN) cn10k_tls_record {
 	union {
 		/** Read SA */
 		struct roc_ie_ot_tls_read_sa read_sa;
 		/** Write SA */
 		struct roc_ie_ot_tls_write_sa write_sa;
 	};
-} __rte_aligned(ROC_ALIGN);
+};
 
 int cn10k_tls_record_session_update(struct cnxk_cpt_vf *vf, struct cnxk_cpt_qp *qp,
 				    struct cn10k_sec_session *sess,
diff --git a/drivers/crypto/cnxk/cn9k_cryptodev_ops.c b/drivers/crypto/cnxk/cn9k_cryptodev_ops.c
index 125a464..96a75a7 100644
--- a/drivers/crypto/cnxk/cn9k_cryptodev_ops.c
+++ b/drivers/crypto/cnxk/cn9k_cryptodev_ops.c
@@ -126,7 +126,7 @@
 cn9k_cpt_enqueue_burst(void *qptr, struct rte_crypto_op **ops, uint16_t nb_ops)
 {
 	struct cpt_inflight_req *infl_req_1, *infl_req_2;
-	struct cpt_inst_s inst[2] __rte_cache_aligned;
+	alignas(RTE_CACHE_LINE_SIZE) struct cpt_inst_s inst[2];
 	struct rte_crypto_op *op_1, *op_2;
 	uint16_t nb_allowed, count = 0;
 	struct cnxk_cpt_qp *qp = qptr;
diff --git a/drivers/crypto/cnxk/cn9k_ipsec.h b/drivers/crypto/cnxk/cn9k_ipsec.h
index d28642e..4e8d815 100644
--- a/drivers/crypto/cnxk/cn9k_ipsec.h
+++ b/drivers/crypto/cnxk/cn9k_ipsec.h
@@ -11,18 +11,18 @@
 #include "cnxk_security.h"
 #include "cnxk_security_ar.h"
 
-struct cn9k_ipsec_sa {
+struct __rte_aligned(8) cn9k_ipsec_sa {
 	union {
 		/** Inbound SA */
 		struct roc_ie_on_inb_sa in_sa;
 		/** Outbound SA */
 		struct roc_ie_on_outb_sa out_sa;
 	};
-} __rte_aligned(8);
+};
 
 #define SEC_SESS_SIZE sizeof(struct rte_security_session)
 
-struct cn9k_sec_session {
+struct __rte_cache_aligned cn9k_sec_session {
 	uint8_t rte_sess[SEC_SESS_SIZE];
 
 	/** PMD private space */
@@ -57,7 +57,7 @@ struct cn9k_sec_session {
 	struct cnxk_cpt_qp *qp;
 
 	struct cn9k_ipsec_sa sa;
-} __rte_cache_aligned;
+};
 
 void cn9k_sec_ops_override(void);
 
diff --git a/drivers/crypto/cnxk/cnxk_cryptodev_ops.h b/drivers/crypto/cnxk/cnxk_cryptodev_ops.h
index e7bba25..46efc4a 100644
--- a/drivers/crypto/cnxk/cnxk_cryptodev_ops.h
+++ b/drivers/crypto/cnxk/cnxk_cryptodev_ops.h
@@ -42,7 +42,7 @@ struct cpt_qp_meta_info {
 #define CPT_OP_FLAGS_IPSEC_DIR_INBOUND (1 << 2)
 #define CPT_OP_FLAGS_IPSEC_INB_REPLAY  (1 << 3)
 
-struct cpt_inflight_req {
+struct __rte_aligned(ROC_ALIGN) cpt_inflight_req {
 	union cpt_res_s res;
 	union {
 		void *opaque;
@@ -59,7 +59,7 @@ struct cpt_inflight_req {
 	uint8_t *rptr;
 #endif
 	void *qp;
-} __rte_aligned(ROC_ALIGN);
+};
 
 PLT_STATIC_ASSERT(sizeof(struct cpt_inflight_req) == ROC_CACHE_LINE_SZ);
 
diff --git a/drivers/crypto/cnxk/cnxk_se.h b/drivers/crypto/cnxk/cnxk_se.h
index c211884..6374718 100644
--- a/drivers/crypto/cnxk/cnxk_se.h
+++ b/drivers/crypto/cnxk/cnxk_se.h
@@ -31,7 +31,7 @@ enum cpt_dp_thread_type {
 
 #define SYM_SESS_SIZE sizeof(struct rte_cryptodev_sym_session)
 
-struct cnxk_se_sess {
+struct __rte_aligned(ROC_ALIGN) cnxk_se_sess {
 	uint8_t rte_sess[SYM_SESS_SIZE];
 
 	uint8_t aes_gcm : 1;
@@ -67,7 +67,7 @@ struct cnxk_se_sess {
 	struct cnxk_cpt_qp *qp;
 	struct roc_se_ctx roc_se_ctx;
 	struct roc_cpt_lf *lf;
-} __rte_aligned(ROC_ALIGN);
+};
 
 struct cnxk_sym_dp_ctx {
 	struct cnxk_se_sess *sess;